/** @file twsdo_ggo.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.5
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef TWSDO_GGO_H
#define TWSDO_GGO_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "twsdo"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "twsdo"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *verbose_xml_help; /**< @brief Never skip xml default values. help description.  */
  char * host_arg;	/**< @brief TWS host name or ip (default: localhost)..  */
  char * host_orig;	/**< @brief TWS host name or ip (default: localhost). original value given at command line.  */
  const char *host_help; /**< @brief TWS host name or ip (default: localhost). help description.  */
  int port_arg;	/**< @brief TWS port number (default: 7474)..  */
  char * port_orig;	/**< @brief TWS port number (default: 7474). original value given at command line.  */
  const char *port_help; /**< @brief TWS port number (default: 7474). help description.  */
  int id_arg;	/**< @brief TWS client connection id (default: 123)..  */
  char * id_orig;	/**< @brief TWS client connection id (default: 123). original value given at command line.  */
  const char *id_help; /**< @brief TWS client connection id (default: 123). help description.  */
  const char *ipv4_help; /**< @brief Force twsapi to use IPv4 addresses only. help description.  */
  const char *ipv6_help; /**< @brief Force twsapi to use IPv6 addresses only. help description.  */
  const char *get_account_help; /**< @brief Request account status. help description.  */
  char * accountName_arg;	/**< @brief IB account name (default: \"\")..  */
  char * accountName_orig;	/**< @brief IB account name (default: \"\"). original value given at command line.  */
  const char *accountName_help; /**< @brief IB account name (default: \"\"). help description.  */
  const char *get_exec_help; /**< @brief Request executions. help description.  */
  const char *get_order_help; /**< @brief Request open orders. help description.  */
  int conTimeout_arg;	/**< @brief Connection timeout (default: 30000)..  */
  char * conTimeout_orig;	/**< @brief Connection timeout (default: 30000). original value given at command line.  */
  const char *conTimeout_help; /**< @brief Connection timeout (default: 30000). help description.  */
  int reqTimeout_arg;	/**< @brief Request timeout (default: 1200000)..  */
  char * reqTimeout_orig;	/**< @brief Request timeout (default: 1200000). original value given at command line.  */
  const char *reqTimeout_help; /**< @brief Request timeout (default: 1200000). help description.  */
  int maxRequests_arg;	/**< @brief Max requests per pacing interval (default: 60)..  */
  char * maxRequests_orig;	/**< @brief Max requests per pacing interval (default: 60). original value given at command line.  */
  const char *maxRequests_help; /**< @brief Max requests per pacing interval (default: 60). help description.  */
  int pacingInterval_arg;	/**< @brief Pacing interval (default: 605000)..  */
  char * pacingInterval_orig;	/**< @brief Pacing interval (default: 605000). original value given at command line.  */
  const char *pacingInterval_help; /**< @brief Pacing interval (default: 605000). help description.  */
  int minPacingTime_arg;	/**< @brief Minimum time to wait between requests (default: 1000)..  */
  char * minPacingTime_orig;	/**< @brief Minimum time to wait between requests (default: 1000). original value given at command line.  */
  const char *minPacingTime_help; /**< @brief Minimum time to wait between requests (default: 1000). help description.  */
  int violationPause_arg;	/**< @brief Time to wait if pacing violation occurs (default: 60000)..  */
  char * violationPause_orig;	/**< @brief Time to wait if pacing violation occurs (default: 60000). original value given at command line.  */
  const char *violationPause_help; /**< @brief Time to wait if pacing violation occurs (default: 60000). help description.  */
  const char *help_help; /**< @brief Show this help message. help description.  */
  const char *version_help; /**< @brief Print version string and exit. help description.  */
  const char *usage_help; /**< @brief Display brief usage message. help description.  */
  
  unsigned int verbose_xml_given ;	/**< @brief Whether verbose-xml was given.  */
  unsigned int host_given ;	/**< @brief Whether host was given.  */
  unsigned int port_given ;	/**< @brief Whether port was given.  */
  unsigned int id_given ;	/**< @brief Whether id was given.  */
  unsigned int ipv4_given ;	/**< @brief Whether ipv4 was given.  */
  unsigned int ipv6_given ;	/**< @brief Whether ipv6 was given.  */
  unsigned int get_account_given ;	/**< @brief Whether get-account was given.  */
  unsigned int accountName_given ;	/**< @brief Whether accountName was given.  */
  unsigned int get_exec_given ;	/**< @brief Whether get-exec was given.  */
  unsigned int get_order_given ;	/**< @brief Whether get-order was given.  */
  unsigned int conTimeout_given ;	/**< @brief Whether conTimeout was given.  */
  unsigned int reqTimeout_given ;	/**< @brief Whether reqTimeout was given.  */
  unsigned int maxRequests_given ;	/**< @brief Whether maxRequests was given.  */
  unsigned int pacingInterval_given ;	/**< @brief Whether pacingInterval was given.  */
  unsigned int minPacingTime_given ;	/**< @brief Whether minPacingTime was given.  */
  unsigned int violationPause_given ;	/**< @brief Whether violationPause was given.  */
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int usage_given ;	/**< @brief Whether usage was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* TWSDO_GGO_H */
