#
# spec file for package twstools
#


Name:           twstools
Version:        0.3.5
Release:        1%{?dist}
Summary:        Command line tools around Interactive Brokers TWS API
License:        BSD-3-Clause
Group:          Productivity/Text/Utilities
URL:            https://github.com/rudimeier/twstools/
Source:         %{name}-%{version}.tar.gz
BuildRequires:  gcc-c++
BuildRequires:  libxml2-devel >= 2.7
BuildRequires:  pkgconfig
BuildRequires:  twsapi-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This is a simple set of command line tools around IB's TWS API with the
purpose of having a powerful scriptable toolbox to automate "jobs" like
downloading historical data, tracking account info or submitting orders
etc.

%prep
%setup -q

%build
%configure --docdir=%{_docdir}/%{name}
make %{?_smp_mflags}

%check
make check

%install
%{?make_install} %{!?make_install:make install DESTDIR=%{buildroot}}
# add samples to docs.
cp -p --parent sample/*.sh sample/*.xml %{buildroot}%{_docdir}/%{name}/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_bindir}/twsdo
%{_bindir}/twsgen
%doc %{_docdir}/%{name}/
%doc %{_mandir}/man1/twsdo.1*
%doc %{_mandir}/man1/twsgen.1*
